# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-JSON-PP
Epoch:		1
Version:	4.05
Release:	1.%{__distinit}%{__distvers}
Summary:	JSON::XS compatible pure-Perl module
License:	GPL+ or Artistic
URL:		https://metacpan.org/release/JSON-PP
Source0:	https://cpan.metacpan.org/modules/by-module/JSON/JSON-PP-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
# Module Runtime
BuildRequires:	perl(bytes)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Math::BigFloat)
BuildRequires:	perl(Math::BigInt)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util) >= 1.08
BuildRequires:	perl(strict)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Script Runtime
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Getopt::Long)
# Test Suite
BuildRequires:	perl(Test)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(Tie::IxHash)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Data::Dumper)
Requires:	perl(Encode)
Requires:	perl(Math::BigFloat)
Requires:	perl(Math::BigInt)
Requires:	perl(Scalar::Util) >= 1.08
Requires:	perl(utf8)
Conflicts:	perl-JSON < 2.50

%description
JSON::XS is the fastest and most proper JSON module on CPAN. It is written by
Marc Lehmann in C, so must be compiled and installed in the used environment.

JSON::PP is a pure-Perl module and is compatible with JSON::XS.

%prep
%setup -q -n JSON-PP-%{version}

%build
# Avoid build failure on F-13 and EL-6 when trying to uninstall existing version
export PERL_NO_HIGHLANDER=1
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README
%{_bindir}/json_pp
%{perl_vendorlib}/JSON/
%{_mandir}/man1/json_pp.1*
%{_mandir}/man3/JSON::PP.3*
%{_mandir}/man3/JSON::PP::Boolean.3*

%changelog
* Thu Jul  9 2020 Paul Howarth <paul@city-fan.org> - 1:4.05-1
- Update to 4.05
  - No code changes
  - Modify tests for Perl 7

* Sat Jun 29 2019 Paul Howarth <paul@city-fan.org> - 1:4.04-1
- Update to 4.04
  - Document indent_length option (GH#48)

* Wed Jun 19 2019 Paul Howarth <paul@city-fan.org> - 1:4.03-1
- Update to 4.03
  - (Encode::)decode json_pp input properly by default (GH#47)

* Sat Feb 23 2019 Paul Howarth <paul@city-fan.org> - 1:4.02-1
- Update to 4.02
  - Fix a test that breaks if perl is compiled with -Dquadmath (CPAN RT#128589)

* Fri Feb 22 2019 Paul Howarth <paul@city-fan.org> - 1:4.01-1
- Update to 4.01
  - Allow to pass indent_length to json_pp (GH#46)

* Fri Dec  7 2018 Paul Howarth <paul@city-fan.org> - 1:4.00-1
- Update to 4.00
  - BACKWARD INCOMPATIBILITY: As JSON::XS 4.0 changed its policy and enabled
    allow_nonref by default, JSON::PP also enabled allow_nonref by default
  - Implement allow_tags that was introduced by JSON::XS 3.0
  - Add boolean_values that was introduced by JSON::XS 4.0
  - Allow literal tags in strings in relaxed mode, as JSON::XS 3.02 does
  - Allow PERL_JSON_PP_USE_B environmental variable to restore old number
    detection behavior for compatibility
  - Various documentation updates
- Drop provides filter, no longer needed

* Wed Jun 27 2018 Paul Howarth <paul@city-fan.org> - 1:2.97.001-416
- Perl 5.28 rebuild

* Fri Dec 22 2017 Paul Howarth <paul@city-fan.org> - 1:2.97.001-1
- Update to 2.97001
  - Tweak internal number detector always to consider a flagged value as a
    string (GH#35)
  - Clarify json_pp options (CPAN RT#123766)

* Tue Nov 21 2017 Paul Howarth <paul@city-fan.org> - 1:2.97-1
- Update to 2.97000
  - Fix is_bool to use blessed() instead of ref()
  - Use 5 digit minor version number for a while to avoid confusion (GH#33)
- Stick to 2 digit minor version downstream as we already bumped epoch

* Mon Nov 20 2017 Paul Howarth <paul@city-fan.org> - 1:2.96-1
- Update to 2.96
  - json_pp now prints an encoded json string (CPAN RT#123653)
  - Fix is_bool to use ->isa("JSON::PP::Boolean"), instead of
    UNIVERSAL::isa("JSON::PP::Boolean") (GH#34)
  - Avoid use of newer Test::More features (CPAN RT#122421)

* Fri Jun 16 2017 Paul Howarth <paul@city-fan.org> - 1:2.94-1
- Epoch bump to match Fedora version

* Mon May 29 2017 Paul Howarth <paul@city-fan.org> - 2.94000-1
- Update to 2.94
  - Fix a test to support perl 5.6

* Wed May 17 2017 Paul Howarth <paul@city-fan.org> - 2.93000-1
- Update to 2.93
  - Changed the number detection logic (experimental)
  - Correct 0 handling (GH#23)
  - Removed base.pm dependency (GH#5)
  - Fixed wrong character offset (CPAN RT#116998)
  - Address VAX issues (CPAN RT#118469)
  - Various documentation fixes
  - Remove . in @INC in json_pp (GH#25, CVE-2016-1238)
  - Removed $VAR1 from json_pp output (GH#11)
  - Fixed an issue to ignore trailing 0 (GH#29)
  - Added Scalar::Util dependency for Perl 5.8+ (CPAN RT#84347)
  - Fixed issues spotted by Nicolas Seriot's JSON Test Suite including
    experimental UTF-16/32 support and backward incompatible change of
    C style comment handling (now disabled by default) (GH#28)
  - Moved the guts of JSON::PP::Boolean into lib/JSON/PP/Boolean.pm and gave
    it a proper version
  - Refactored incremental parser to let it handle incomplete JSON text
    properly
  - Imported and tweaked tests from JSON.pm
  - Minor code clean up
  - Fixed not to fail tests under Perl 5.25.* (CPAN RT#119114)
  - Reworked documentation, based on the one for JSON::XS
  - Let json_pp utility show the version of JSON::PP
  - Fix loading order of B module (GH#31)
  - Fixed isa tests for bignum
- This release by ISHIGAKI → update source URL
- Use five-digit version number for rpm to maintain upgrade path
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Wed Aug  3 2016 Paul Howarth <paul@city-fan.org> - 2.27400-4
- Avoid loading optional modules from default . (CVE-2016-1238)
- BR: perl-generators where available

* Mon Apr 25 2016 Paul Howarth <paul@city-fan.org> - 2.27400-1
- Update to 2.27400
  - Applied and merged long term neglected patches and pull requests
  - Modified Makefile.PL to set UNINST=1 if needed on old perls
  - Decode decimals to Perl's internal NV type
- Simplify find command using -delete

* Wed Oct  8 2014 Paul Howarth <paul@city-fan.org> - 2.27300-1
- Update to 2.27300
  - Fixed a problem about substr in perl 5.8.6 and below
- Classify buildreqs by usage

* Fri Aug 29 2014 Paul Howarth <paul@city-fan.org> - 2.27203-3
- Drop %%defattr, redundant since rpm 4.4

* Fri Oct 18 2013 Paul Howarth <paul@city-fan.org> - 2.27203-1
- Update to 2.27203
  - Fixed return/or in _incr_parse (CPAN RT#86948)
- Specify all dependencies

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> - 2.27202-290
- Perl 5.18 rebuild

* Wed Mar 13 2013 Paul Howarth <paul@city-fan.org> - 2.27202-1
- Update to 2.27202
  - Fix test failures due to hash iterator randomization in perl 5.17.6 onwards
    (CPAN RT#83421)

* Mon Jun 25 2012 Paul Howarth <paul@city-fan.org> - 2.27200-5
- BR: perl(base), perl(Carp), perl(constant), perl(Data::Dumper),
  perl(Exporter) and perl(lib)
- Install to vendor directories
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 2.27200-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun May 22 2011 Paul Howarth <paul@city-fan.org> - 2.27200-1
- Update to 2.27200
  - Fixed incr_parse decoding string more correctly (CPAN RT#68032)
- Nobody else likes macros for commands

* Tue Mar  8 2011 Paul Howarth <paul@city-fan.org> - 2.27105-1
- Update to 2.27105
  - Removed t/900_pod.t from package because of author test
- Drop buildreq perl(Test::Pod), no longer needed

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> - 2.27104-2
- Conflict with perl-JSON < 2.50 (#672764)

* Tue Jan 25 2011 Paul Howarth <paul@city-fan.org> - 2.27104-1
- Initial RPM version
